package UNIVERSAL;

sub import {
    my($exporter, @imports)  = @_;
    my($caller, $file, $line) = caller;

    # XXX Can't tell difference between "use Module" and "use Module ()"
    unless( @imports ) {        # Default import.
        @imports = @{$exporter.'::EXPORT'};
    }
    else {
        if( @{$exporter.'::EXPORT_FAIL'} ) {
            # This can be cached.
            my %fail = map { $_ => 1 } @{$exporter.'::EXPORT_FAIL'};

            my($denied) = grep {$fail{$_}} @imports;
            _not_exported($denied, $exporter, $file, $line) if $denied;
        }

        # Because @EXPORT_OK = () would indicate that nothing is
        # to be exported, we cannot simply check the length of @EXPORT_OK.
        # We must to oddness to see if the variable exists at all as
        # well as avoid autovivification.
        # XXX idea stolen from base.pm, this might be all unnecessary
        my $eokglob;
        if( $eokglob = ${$exporter.'::'}{EXPORT_OK} and *$eokglob{ARRAY} ) {
            if( @{$exporter.'::EXPORT_OK'} ) {
                # This can also be cached.
                my %ok = map { $_ => 1} @{$exporter.'::EXPORT_OK'},
                                        @{$exporter.'::EXPORT'};

                my($denied) = grep {!$ok{$_}} @imports;
                _not_exported($denied, $exporter, $file, $line) if $denied;
            }
            else {      # We don't export anything.
                _not_exported($imports[0], $exporter, $file, $line);
            }
        }
       
    }

    _export($caller, $exporter, @imports);
}


sub exports {
    my($exporter) = shift;

    my %exports = map { $_ => 1 } @{$exporter.'::EXPORT'}, 
                                  @{$exporter.'::EXPORT_OK'};

    if( @_ ) {
        return exists $exports{$_[0]};
    }
    else {
        return keys %exports;
    }
}
        

sub _export {
    my($caller, $exporter, @imports) = @_;

    # Stole this from Exporter::Heavy.  I'm sure it can be written better
    # but I'm lazy at the moment.
    foreach $sym (@imports) {
        # shortcut for the common case of no type character
        (*{"${caller}::$sym"} = \&{"${exporter}::$sym"}, next)
            unless $sym =~ s/^(\W)//;
        my $type = $1;
        *{"${caller}::$sym"} =
            $type eq '&' ? \&{"${exporter}::$sym"} :
            $type eq '$' ? \${"${exporter}::$sym"} :
            $type eq '@' ? \@{"${exporter}::$sym"} :
            $type eq '%' ? \%{"${exporter}::$sym"} :
            $type eq '*' ?  *{"${exporter}::$sym"} :
            do { require Carp; Carp::croak("Can't export symbol: $type$sym") };
    }
}


#"#
sub _not_exported {
    my($thing, $exporter, $file, $line) = @_;
    die sprintf qq|"%s" is not exported by the %s module at %s line %d\n|,
        $thing, $exporter, $file, $line;
}

1;
